declare module "react-tech-tree" {
  export interface INodeData {
    name: string;
    id: string;
    className?: string;
  }
  export interface ILinkData {
    from: string;
    to: string;
    className?: string;
  }
  export interface ITreeData {
    nodes: INodeData[][];
    links: ILinkData[];
  }
  interface TreeProps<T extends NodeProps> extends ITreeData {
    id: string;
    nodeProps?: object;
    linkProps?: object;
    NodeElement?: React.FC<T>;
  }
  interface NodeProps {
    id: string;
    onClick?: (e: MouseEvent) => void;
  }

  declare function Node<T extends NodeProps>(props: T): JSX.Element;
  declare function Tree<T extends NodeProps>(props: T): JSX.Element;

  declare function prepareSpritesheetStyle(
    a: string,
    b: object
  ): (name: string) => React.CSSProperties;
  declare function nodeClickHandler(e: React.MouseEvent<HTMLElement>): void;

  export { Tree, prepareSpritesheetStyle, nodeClickHandler, Node };
}
